'use strict';
//Scoped object for the entire project
var sinclairDigital = sinclairDigital || {};

//sinclairDigital.core = '//static-16.sinclairstoryline.com/resources/assets/2016-02-03T23-06Z';
//DEFINE the dependencies to be used for the whole project with thier links
var DEPENDENCIES = {
    '$': {
        url: sinclairDigital.core + '/shared/jquery/jquery.min.js'
    },
    'fetchStations': {
        url: sinclairDigital.core + '/shared/schedule-config.js'
    },
    'jQueryUI': {
        url: sinclairDigital.core + '/shared/jquery-ui.min.js',
        dependencies: ['$']
    },
    'sdPageloaded': {
        url: sinclairDigital.core + '/shared/pageloaded.js'
    },
    'Handlebars': {
        url: 'https://cdnjs.cloudflare.com/ajax/libs/handlebars.js/3.0.0/handlebars.min.js'
    },
    'Handlebars.4.0.5': {
        url: sinclairDigital.core + '/shared/handlebars/handlebars-v4.0.5.js'
    },
    'Handlebars.templates': {
        url: sinclairDigital.core + '/shared/handlebars/storyBlock.handlebars.js',
        dependencies: ['Handlebars.4.0.5']
    },
    'adsStoryBlock': {
        url: sinclairDigital.core + '/shared/handlebars/sinclairAdsStoryBlock.handlebars.js',
        dependencies: ['Handlebars.4.0.5']
    },
    'sd.templates': {
        url: sinclairDigital.core + '/shared/handlebars/compiled.handlebars.js',
        dependencies: ['Handlebars']
    },
    '_': {
        url: sinclairDigital.core + '/shared/underscore/underscore-min.js'
    },
    'moment': {
        url: sinclairDigital.core + '/shared/moment/moment.min.js'
    },
    'Cookies': {
        url: sinclairDigital.core + '/shared/jquery/js.cookie.js',
        dependencies: ['$']
    },
    'Swiper': {
        url: sinclairDigital.core + '/shared/swiper/swiper.jquery.min.js',
        dependencies: ['$']
    },
    'jwplayer': {
        url :sinclairDigital.jwplayerUrl,
        dependencies: ['$']
    },
    'Backbone': {
        url: sinclairDigital.core + '/shared/backbone/backbone-min.js',
        dependencies: ['_']
    },
    'jQuery.validator': {
        url: sinclairDigital.core + '/shared/jquery/jquery.validate.min.js',
        dependencies: ['$']
    },
    'sdEmbeds': {
        url: sinclairDigital.core + '/shared/jquery/sd.embeds.js',
        dependencies: ['gapi.load', 'jwplayer', 'CnnVanDiscoverWidgets.init', 'twttr', 'YT', '$','vodPlayer']
    },
    'jQuery.xml2json': {
        url: sinclairDigital.core + '/shared/xml2json.js',
        dependencies: ['$']
    },
    'SinclairWidgets': {
        url: sinclairDigital.core + '/shared/widgets.js',
        dependencies: ['Handlebars', 'sd.templates', '$']
    },
    'hoverIntent': {
        url: sinclairDigital.core + '/shared/jquery/jquery.hoverIntent.min.js',
        dependencies: ['$']
    },
    'throttle': {
        url: sinclairDigital.core + '/shared/jquery/jquery.ba-throttle-debounce.min.js',
        dependencies: ['$']
    },
    'twitterFetcher': {
        url: sinclairDigital.core + '/shared/twitterFetcher.js',
        dependencies: ['$', 'twttr']
    },
    'debounce': {
        url: sinclairDigital.core + '/shared/jquery/jquery.ba-throttle-debounce.min.js',
        dependencies: ['$']
    },
    'modal': {
        url: sinclairDigital.core + '/shared/modal/modal.js',
        dependencies: ['$']
    },
    'tabs': {
        url: sinclairDigital.core + '/shared/tab.js',
        dependencies: ['$']
    },
    'scrollLock': {
        url: sinclairDigital.core + '/shared/jquery/jquery.scrollLock.js',
        dependencies: ['$']
    },
    'jwplayer6Loaded': {
        url: sinclairDigital.core + '/shared/jwplayer/jwplayer6Loaded.js',
        dependencies: ['$']
    },
    'jwplayerLoaded': {
        url: sinclairDigital.core + '/shared/jwplayer/jwplayerLoaded.js',
        dependencies: ['$', 'jwplayer']
    },
    'vodPlayer': {
        url: sinclairDigital.core + '/shared/vodPlayer.js',
        dependencies: ['jwplayerLoaded', 'tabs', 'scrollLock', '$']
    },
    'gapi.load': {
        url: 'https://apis.google.com/js/platform.js'
    },
    'CnnVanDiscoverWidgets.init': {
        url: 'http://z.cdn.turner.com/cnn/van/resources/scripts/van-widgets.js'
    },
    'lazyload': {
        url: sinclairDigital.core + '/shared/jquery/jquery.lazyload.js',
        dependencies: ['$']
    },
    'lazySizes': {
        url: sinclairDigital.core + '/shared/lazysizes/lazysizes.min.js',
        dependencies: ['$']
    },
    'sinclairDigital.teaserPlayer': {
        url: sinclairDigital.core + '/shared/teaserPlayer.js',
        dependencies: ['jwplayerLoaded', '$']
    },
    'twttr': {
        url: '//platform.twitter.com/widgets.js'
    },
    'IScroll': {
        url: sinclairDigital.core + '/shared/iscroll.js',
        dependencies: ['$']
    },
    'FB': {
        url: sinclairDigital.core + '/shared/facebookAPI.js',
        dependencies: ['$']
    },
    'YT': { //YOUTUBE
        url: '//www.youtube.com/iframe_api'
    },
    'mv-widgets': {
        url: '//d6launbk5pe1s.cloudfront.net/widget.js'
    },
    'Qzzr': {
        url: '//dcc4iyjchzom0.cloudfront.net/widget/loader.js'
    },
    'FTScroller': {
        url: sinclairDigital.core + '/shared/ftscroller.js',
        dependencies: ['$']
    },
    'ScrollSpy': {
        url: sinclairDigital.core + '/shared/scrollspy/scrollspy.js',
        dependencies: ['$']
    },
    'masonry': {
        url: sinclairDigital.core + '/shared/masonry/autoload.masonry.pkgd.min.js',
        dependencies: ['$']
    },
    'velocity': {
        url: sinclairDigital.core + '/shared/velocity.min.js'
    },
    'iframeResizer': {
        url: sinclairDigital.core + '/shared/iframeResizer/iframeResizer.min.js'
    },
    '$YB': {
        url: 'http://smartplugin.youbora.com/v5/javascript/jwplayer/5.3.0/sp.min.js'
    }
};
var sinclairDependencies = {
    errors: {
        count: 0
    }
};

sinclairDigital.dependencies = (function(window, document, sinclairDigital, sinclairDependencies) {
    sinclairDigital.core = sinclairDigital.core || '/';
    sinclairDigital.errors = sinclairDigital.errors || {};
    sinclairDependencies.keyedDependencies = {};
    sinclairDependencies.urls = {};
    sinclairDependencies.loadLast = [];
    var load,
        define,
        add,
        require,
        register,
        action,
        _reportError,
        _worklistItemReady,
        _loadedVerifier,
        _thirdPartyVerifier,
        _thirdPartyJsObjCreate,
        _keyedJsObjCreate,
        _addToList,
        _processWorklist,
        _processWorklistItem,
        _worklistItemOptionalFetch,
        _triggerWorklistProcessing,
        _depLoaded,
        _worklistItemCheckLoaded,
        _worklistItemExecute,
        _addDependencies,
        _addDependency,
        _standAloneCallbacks,
        _reportsuccess,
        _getAction,
        _worklistItemDepsDoubleChecker,
        _loadError,
        _hasUnloadedDependency,
        _proccessCount = 0,
        _proccessLimit = 100;



    _addToList = function(jsDepObj) {
        sinclairDependencies.worklist = sinclairDependencies.worklist || [];
        sinclairDependencies.worklist.push(jsDepObj);
        window.sinclairDigital.dependencies.worklist = sinclairDependencies.worklist;
        return jsDepObj;
    };
    _keyedJsObjCreate = function(keyedDep) {
        if (!sinclairDependencies.keyedDependencies.hasOwnProperty(keyedDep.key)) {
            sinclairDependencies.keyedDependencies[keyedDep.key] = _addToList({
                key: keyedDep.key,
                url: keyedDep.url,
                dependencies: [],
                state: '',
                callback: null,
                verifier: function(worklistItem) {
                    return typeof worklistItem.callback === 'function';
                },
                executor: function(worklistItem) {
                    worklistItem.callback();
                }
            });
        }
        return sinclairDependencies.keyedDependencies[keyedDep.key];
    };
    _thirdPartyJsObjCreate = function(thirdPartyKey) {
        if (!DEPENDENCIES.hasOwnProperty(thirdPartyKey)) {
            _reportError('Third Party Dependency Not Available - ' + thirdPartyKey);
        } else if (!sinclairDependencies.keyedDependencies.hasOwnProperty(thirdPartyKey)) {
            var url = DEPENDENCIES[thirdPartyKey].url,
                deps = DEPENDENCIES[thirdPartyKey].dependencies || [];
            deps.forEach(_thirdPartyJsObjCreate);
            sinclairDependencies.keyedDependencies[thirdPartyKey] = _addToList({
                key: thirdPartyKey,
                url: url,
                dependencies: deps,
                state: '',
                callback: null,
                verifier: function(worklistItem) {
                    return _worklistItemReady(worklistItem.key);
                },
                executor: function(worklistItem) {}
            });
        }
        return sinclairDependencies.keyedDependencies[thirdPartyKey];
    };
    require = function(thirdPartyDeps, keyedDeps) {
        thirdPartyDeps.forEach(_thirdPartyJsObjCreate);
        for (var keyedDep in keyedDeps) {
            _keyedJsObjCreate(keyedDeps[keyedDep]).dependencies = thirdPartyDeps;
        }
    };
    _addDependency = function(worklistItem, depWorklistItem) {
        worklistItem.dependencies.push(depWorklistItem.key);

    };
    register = function(key, thirdPartyDeps, keyedDeps, callback) {

        var worklistItem = sinclairDependencies.keyedDependencies[key];
        if (worklistItem) {
            for (var thirdPartyDep in thirdPartyDeps) {
                _addDependency(worklistItem, _thirdPartyJsObjCreate(thirdPartyDeps[thirdPartyDep]));
            }
            for (var keyedDep in keyedDeps) {
                _addDependency(worklistItem, _keyedJsObjCreate(keyedDeps[keyedDep]));
            }
            worklistItem.callback = callback;
        }
    };
    _standAloneCallbacks = [];
    define = function(deps, callback, updated) {
        if (!updated) {
            _reportError('define called: ' + deps + ' ' + callback);
        }
        if (deps.length > 0) {
            deps.forEach(_thirdPartyJsObjCreate);
        }
        _standAloneCallbacks.push(callback);
    };
    add = function(scriptArray) {
        _reportError('add: ', scriptArray);
    };
    _depLoaded = function(depKey) {
        return _getAction(sinclairDependencies.keyedDependencies[depKey]) === action.remove;
    };
    _loadError = function(oError, worklistItem) {
        //throw new URIError("The script " + oError.target.src + " is not accessible.");
        worklistItem.verifier = true;
        worklistItem.state = 'failed';
        window[worklistItem.key] = oError;
        _reportError('Did Not Execute: ' + worklistItem.key + ' : The script ' + oError.target.src + ' is not accessible.');

    };
    _worklistItemOptionalFetch = function(worklistItem) {

        for (var depKey in worklistItem.dependencies) {
            var isLoaded = _depLoaded(worklistItem.dependencies[depKey]);
            if (!isLoaded) {
                return;
            }
        }
        worklistItem.state = 'fetching';
        //     (function () {
        //     var s = document.createElement('script');
        //     s.type = 'text/javascript';
        //     s.async = true;
        //     s.src = 'js/jquery-ui-1.8.16.custom.min.js';
        //     var x = document.getElementsByTagName('script')[0];
        //     x.parentNode.insertBefore(s, x);
        // })();

        var script = document.createElement("script");
        script.type = "text/javascript";

        if (script.readyState) { //IE
            script.onreadystatechange = function() {

                if (script.readyState == "loaded" ||
                    script.readyState == "complete") {
                    script.onreadystatechange = null;
                    //callback();
                    worklistItem.state = 'loaded';
                }
            };
        } else { //Others
            script.onload = function() {
                //callback();
                worklistItem.state = 'loaded';
            };
            script.onerror = function(err) {
                _loadError(err, worklistItem);
            };

        }

        if (worklistItem.state != 'fetched') {
            worklistItem.state = 'fetched';
            script.src = worklistItem.url;

            sinclairDependencies.urls[worklistItem.url] = sinclairDependencies.urls[worklistItem.url] || [];
            if (sinclairDependencies.urls[worklistItem.url].length < 1) {
                document.getElementsByTagName("head")[0].appendChild(script);
            }
            sinclairDependencies.urls[worklistItem.url].push(worklistItem.key);


        }


        //!!!!!!!!!!!!!!!!!! USING AJAX !!!!!!!!!!!!!!!!!!!!!!!//
        // $.ajax({
        //     dataType: 'script',
        //     cache: true,
        //     url: worklistItem.url
        // }).done(function(){
        //     worklistItem.state = 'fetched';
        //     //_processWorklist();
        // }).fail(function(error){
        //     worklistItem.state = 'failed';
        //     //_processWorklist();
        //     _reportError('AJAX Fetch Failed: '+worklistItem.key+' : '+worklistItem.url+ ' ', error);
        // });
    };
    _reportError = function(error) {
        var len = sinclairDependencies.errors.count++;
        sinclairDependencies.errors[len] = error;
    };
    _reportsuccess = function(success) {
        var len = sinclairDependencies.success.count++;
        sinclairDependencies.success[len] = success;
    };
    _worklistItemCheckLoaded = function(worklistItem) {
        if (worklistItem.verifier(worklistItem)) {
            worklistItem.state = 'loaded';
        }
    };
    _worklistItemReady = function(key) {
        if (typeof window[key] !== 'undefined') {
            return true;
        }
        var keyArray = '';
        if(typeof key ==='string'){
            keyArray = key.split('.');
        }
        if (typeof window[keyArray[0]] !== 'undefined') {
            return true;
        }
        return false;
    };
    _worklistItemDepsDoubleChecker = function(worklistItem) {
        var deps = worklistItem.dependencies;
        for (var dep in deps) {
            if (!_worklistItemReady(deps[dep])) {
                return false;
            }
        }
        return true;
    };
    _worklistItemExecute = function(worklistItem) {
        if (_worklistItemDepsDoubleChecker(worklistItem)) {
            try {
                worklistItem.executor(worklistItem);
                worklistItem.state = 'executed';
            } catch (err) {
                worklistItem.state = 'failed';
                _reportError('Did Not Execute: ' + worklistItem.key + ' : ' + err);
            }
        }
    };
    action = {
        optionalFetch: 'optionalFetch',
        noOp: 'noOp',
        checkLoaded: 'checkLoaded',
        execute: 'execute',
        remove: 'remove'

    };
    _getAction = function(worklistItem) {
        var work = action.noOp;
        if (worklistItem) {
            var state = worklistItem.state || 'require';
            switch (state) {
                case 'require':
                    work = action.optionalFetch;
                    break;
                case 'fetching':
                    break;
                case 'fetched':
                    work = action.checkLoaded;
                    break;
                case 'loaded':
                    work = action.execute;
                    break;
                case 'executed':
                case 'failed':
                    work = action.remove;
                    break;
                default:
                    _reportError('unexpected state of worklist item:' + state);
            }
        }
        // console.log(worklistItem.key, state, work, sinclairDependencies.keyedDependencies[worklistItem.key].dependencies)
        return work;
    };

    _processWorklistItem = function(worklistItem) {
        var keep = false,
            remove = true,
            worklistAction = _getAction(worklistItem);
        switch (worklistAction) {
            case action.noOp:
            case action.optionalFetch:
                _worklistItemOptionalFetch(worklistItem);
                return keep;
            case action.checkLoaded:
                _worklistItemCheckLoaded(worklistItem);
                return keep;
            case action.execute:
                _worklistItemExecute(worklistItem);
                return keep;
            case action.remove:
                return remove;
            default:
                _reportError('unexpected action of worklist item:' + worklistItem.key + ' ' + worklistAction);
                return keep;
        }
    };

    _hasUnloadedDependency = function(worklistItem, dep) {
        for (var i = sinclairDependencies.keyedDependencies[worklistItem.key].dependencies.length; i-- > 0;) {
            if (sinclairDependencies.keyedDependencies[worklistItem.key].dependencies[i] == dep && typeof window[dep] == 'undefined') {
                sinclairDependencies.loadLast.push(worklistItem);
                return true;
            }
        }
        return false;
    };
    _processWorklist = function() {
        var to = clearTimeout(to);
        for (var i = sinclairDependencies.worklist.length; i-- > 0;) {
            if (_hasUnloadedDependency(sinclairDependencies.worklist[i], 'sdPageloaded') || _processWorklistItem(sinclairDependencies.worklist[i])) {
                sinclairDependencies.worklist.splice(i, 1);
            }
        }
        to = setTimeout(function() {
            _proccessCount++;
            if (sinclairDependencies.worklist.length > 0 && _proccessCount < _proccessLimit) {
                _processWorklist();

            } else if (sinclairDependencies.loadLast.length > 0 && _proccessCount < _proccessLimit) {
                window.sdPageloaded = {};
                sinclairDependencies.worklist = sinclairDependencies.loadLast;
                sinclairDependencies.loadLast = [];
                _processWorklist();
            } else {
                window.sdPageloaded = {};


                for (var callback in _standAloneCallbacks) {
                    if (typeof _standAloneCallbacks[callback] === 'function') {
                        try {
                            _standAloneCallbacks[callback]();
                        } catch (err) {
                            _reportError('callbacks: ' + err);
                        }
                    }

                }
            }
        }, 100);
    };


    load = function() {
        _proccessCount = 0;
        _proccessLimit = 1000;
        sinclairDependencies = sinclairDependencies || {};
        if (sinclairDependencies.hasOwnProperty('worklist')) {
            _processWorklist();
        }
    };

    return {
        load: load,
        define: define,
        add: add,
        require: require,
        register: register
    };

})(window, document, sinclairDigital, sinclairDependencies);
